/*
 *  Command.h
 *  godivacli
 *
 *  Created by Claudio Bisegni on 25/09/10.
 *  Copyright 2010 INFN. All rights reserved.
 *
 */
#ifndef COMMAND_H
#define COMMAND_H
#include "soapRefWSApiCallInterfacePortBindingProxy.h" 
#include <vector>
#include <string>


/*!
    @class       Command
    @abstract    <#(brief description)#>
    @discussion  <#(comprehensive description)#>
*/
class Command {
protected:
	std::string *apiGroup;
	std::string *apiName;
	ns1__refwsCallResult *apiResult;
	
	void setApiResult(ns1__refwsCallResult*);
private:
	struct soap *soap;
	static std::string clientCertPath;
	static std::string clientCertPwd;
	
	//godiva soap service
	static RefWSApiCallInterfacePortBindingProxy service;
	static bool soapServiceInitialized;
	
	//print serialization
	static bool printSerialization;
	
	//vector with param for soap service call
	std::vector<xsd__anyType*>  paramToSerialize;
	
	//method for serialize 
	std::string* serializeParam(ns1__refwsCallParam*);
	void deserializeParam(std::string*);
	

public:
	Command(const char*,const char*);
	~Command();
	
	//assigna static value for client cert file path
	static void setClientCertPath(std::string *cCertFilePath){
		if(!cCertFilePath)return;
		clientCertPath = *cCertFilePath;
	}
	
	//assigna static value for client cert file path
	static void setClientCertPassword(std::string *pwd){
		if(!pwd)return;
		clientCertPwd = *pwd;
	}
	
	//assign static value for client serialization print flag
	static void setClientPrintSerialization(bool printSerializationFlag){
		printSerialization=printSerializationFlag;
	}
	//------------------target---------------------
	void setEndPoint(const char *);
	bool inError();
    bool isMultipleResult();
	const char * getErrorString();
	xsd__anyType* getResult();
	std::vector<xsd__anyType*>  *getMultipleResult();
	//------------------action---------------------
	virtual void call();
	
	//-------------------param---------------------
	void addServiceParam(xsd__anyType* param);
	void clearParam();
	
};
#endif