//
//  MainController.h
//  godivacli
//
//  Created by Claudio Bisegni on 16/10/10.
//  Copyright (c) 2010 INFN. All rights reserved.
//
#ifndef MainController_H
#define MainController_H
/******************************************************************
 *
 *
 *
 *****************************************************************/
#include <string>
#include <vector>
#include <tclap/CmdLine.h>

#define GODIVA_PROMPT	"godivacli> "
#define PROTOCOLL_SSL	"https://"
#define PROTOCOLL_NOSSL	"http://"
#define HOST			"godiva.infn.it"
#define PORT			8443
/*
 request command
 */
class MainController {
private:

protected:
    int argc;
    char** argv;
	
	std::string serverURL;
	
    TCLAP::CmdLine *cmd;
    TCLAP::ValueArg<std::string> *ufcArg;
    
	TCLAP::ValueArg<std::string> *syncFromProtoservArg;
	
    TCLAP::SwitchArg *uidFromNameSurnameSwitch;
    TCLAP::ValueArg<std::string> *ufnsName;
    TCLAP::ValueArg<std::string> *ufnsSurname;
    
    TCLAP::SwitchArg *noSSLSwitch;
    TCLAP::ValueArg<std::string> *hostArg;
    TCLAP::ValueArg<int> *portArg;
    
    TCLAP::ValueArg<std::string> *clientCertArg;
    TCLAP::ValueArg<std::string> *clientCertPwdArg;
    
    
    TCLAP::SwitchArg *printSerializeXMLArg;
	TCLAP::SwitchArg *interactiveModeArg;
	TCLAP::SwitchArg *quitInteractiveModeArg;
    
public:
	MainController(int argCount, char** argValue);
	~MainController();
    virtual void start();
protected:
	void composeServerURL();
	void interactiveMode();
	bool checkAndExecuteCommand();
    void getUserCommand(std::vector<std::string>&);
    void tokenizeSentence(const std::string&, std::vector<std::string>&, const std::string&);
	//-----------------------------------command---------------------------------------------
	void executeAuthentication();
	void executeUFC(const char *);
	void executeSFP(const char *);
	void executeUidFromNameSurname(const char *, const char *);
};

#endif